git-submodule.shon commit commit: allow partial commits with relative paths (8894d53)
   1#!/bin/sh
   2#
   3# git-submodules.sh: add, init, update or list git submodules
   4#
   5# Copyright (c) 2007 Lars Hjemli
   6
   7dashless=$(basename "$0" | sed -e 's/-/ /')
   8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
   9   or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
  10   or: $dashless [--quiet] init [--] [<path>...]
  11   or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
  12   or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
  13   or: $dashless [--quiet] foreach [--recursive] <command>
  14   or: $dashless [--quiet] sync [--] [<path>...]"
  15OPTIONS_SPEC=
  16. git-sh-setup
  17. git-parse-remote
  18require_work_tree
  19
  20command=
  21branch=
  22force=
  23reference=
  24cached=
  25recursive=
  26init=
  27files=
  28nofetch=
  29update=
  30prefix=
  31
  32# Resolve relative url by appending to parent's url
  33resolve_relative_url ()
  34{
  35        remote=$(get_default_remote)
  36        remoteurl=$(git config "remote.$remote.url") ||
  37                die "remote ($remote) does not have a url defined in .git/config"
  38        url="$1"
  39        remoteurl=${remoteurl%/}
  40        sep=/
  41        while test -n "$url"
  42        do
  43                case "$url" in
  44                ../*)
  45                        url="${url#../}"
  46                        case "$remoteurl" in
  47                        */*)
  48                                remoteurl="${remoteurl%/*}"
  49                                ;;
  50                        *:*)
  51                                remoteurl="${remoteurl%:*}"
  52                                sep=:
  53                                ;;
  54                        *)
  55                                die "cannot strip one component off url '$remoteurl'"
  56                                ;;
  57                        esac
  58                        ;;
  59                ./*)
  60                        url="${url#./}"
  61                        ;;
  62                *)
  63                        break;;
  64                esac
  65        done
  66        echo "$remoteurl$sep${url%/}"
  67}
  68
  69#
  70# Get submodule info for registered submodules
  71# $@ = path to limit submodule list
  72#
  73module_list()
  74{
  75        git ls-files --error-unmatch --stage -- "$@" |
  76        perl -e '
  77        my %unmerged = ();
  78        my ($null_sha1) = ("0" x 40);
  79        while (<STDIN>) {
  80                chomp;
  81                my ($mode, $sha1, $stage, $path) =
  82                        /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
  83                next unless $mode eq "160000";
  84                if ($stage ne "0") {
  85                        if (!$unmerged{$path}++) {
  86                                print "$mode $null_sha1 U\t$path\n";
  87                        }
  88                        next;
  89                }
  90                print "$_\n";
  91        }
  92        '
  93}
  94
  95#
  96# Map submodule path to submodule name
  97#
  98# $1 = path
  99#
 100module_name()
 101{
 102        # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
 103        re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
 104        name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
 105                sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
 106       test -z "$name" &&
 107       die "No submodule mapping found in .gitmodules for path '$path'"
 108       echo "$name"
 109}
 110
 111#
 112# Clone a submodule
 113#
 114# Prior to calling, cmd_update checks that a possibly existing
 115# path is not a git repository.
 116# Likewise, cmd_add checks that path does not exist at all,
 117# since it is the location of a new submodule.
 118#
 119module_clone()
 120{
 121        path=$1
 122        url=$2
 123        reference="$3"
 124
 125        if test -n "$reference"
 126        then
 127                git-clone "$reference" -n "$url" "$path"
 128        else
 129                git-clone -n "$url" "$path"
 130        fi ||
 131        die "Clone of '$url' into submodule path '$path' failed"
 132}
 133
 134#
 135# Add a new submodule to the working tree, .gitmodules and the index
 136#
 137# $@ = repo path
 138#
 139# optional branch is stored in global branch variable
 140#
 141cmd_add()
 142{
 143        # parse $args after "submodule ... add".
 144        while test $# -ne 0
 145        do
 146                case "$1" in
 147                -b | --branch)
 148                        case "$2" in '') usage ;; esac
 149                        branch=$2
 150                        shift
 151                        ;;
 152                -f | --force)
 153                        force=$1
 154                        ;;
 155                -q|--quiet)
 156                        GIT_QUIET=1
 157                        ;;
 158                --reference)
 159                        case "$2" in '') usage ;; esac
 160                        reference="--reference=$2"
 161                        shift
 162                        ;;
 163                --reference=*)
 164                        reference="$1"
 165                        shift
 166                        ;;
 167                --)
 168                        shift
 169                        break
 170                        ;;
 171                -*)
 172                        usage
 173                        ;;
 174                *)
 175                        break
 176                        ;;
 177                esac
 178                shift
 179        done
 180
 181        repo=$1
 182        path=$2
 183
 184        if test -z "$path"; then
 185                path=$(echo "$repo" |
 186                        sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 187        fi
 188
 189        if test -z "$repo" -o -z "$path"; then
 190                usage
 191        fi
 192
 193        # assure repo is absolute or relative to parent
 194        case "$repo" in
 195        ./*|../*)
 196                # dereference source url relative to parent's url
 197                realrepo=$(resolve_relative_url "$repo") || exit
 198                ;;
 199        *:*|/*)
 200                # absolute url
 201                realrepo=$repo
 202                ;;
 203        *)
 204                die "repo URL: '$repo' must be absolute or begin with ./|../"
 205        ;;
 206        esac
 207
 208        # normalize path:
 209        # multiple //; leading ./; /./; /../; trailing /
 210        path=$(printf '%s/\n' "$path" |
 211                sed -e '
 212                        s|//*|/|g
 213                        s|^\(\./\)*||
 214                        s|/\./|/|g
 215                        :start
 216                        s|\([^/]*\)/\.\./||
 217                        tstart
 218                        s|/*$||
 219                ')
 220        git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
 221        die "'$path' already exists in the index"
 222
 223        if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
 224        then
 225                echo >&2 "The following path is ignored by one of your .gitignore files:" &&
 226                echo >&2 $path &&
 227                echo >&2 "Use -f if you really want to add it."
 228                exit 1
 229        fi
 230
 231        # perhaps the path exists and is already a git repo, else clone it
 232        if test -e "$path"
 233        then
 234                if test -d "$path"/.git -o -f "$path"/.git
 235                then
 236                        echo "Adding existing repo at '$path' to the index"
 237                else
 238                        die "'$path' already exists and is not a valid git repo"
 239                fi
 240
 241                case "$repo" in
 242                ./*|../*)
 243                        url=$(resolve_relative_url "$repo") || exit
 244                    ;;
 245                *)
 246                        url="$repo"
 247                        ;;
 248                esac
 249                git config submodule."$path".url "$url"
 250        else
 251
 252                module_clone "$path" "$realrepo" "$reference" || exit
 253                (
 254                        clear_local_git_env
 255                        cd "$path" &&
 256                        # ash fails to wordsplit ${branch:+-b "$branch"...}
 257                        case "$branch" in
 258                        '') git checkout -f -q ;;
 259                        ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
 260                        esac
 261                ) || die "Unable to checkout submodule '$path'"
 262        fi
 263
 264        git add $force "$path" ||
 265        die "Failed to add submodule '$path'"
 266
 267        git config -f .gitmodules submodule."$path".path "$path" &&
 268        git config -f .gitmodules submodule."$path".url "$repo" &&
 269        git add --force .gitmodules ||
 270        die "Failed to register submodule '$path'"
 271}
 272
 273#
 274# Execute an arbitrary command sequence in each checked out
 275# submodule
 276#
 277# $@ = command to execute
 278#
 279cmd_foreach()
 280{
 281        # parse $args after "submodule ... foreach".
 282        while test $# -ne 0
 283        do
 284                case "$1" in
 285                -q|--quiet)
 286                        GIT_QUIET=1
 287                        ;;
 288                --recursive)
 289                        recursive=1
 290                        ;;
 291                -*)
 292                        usage
 293                        ;;
 294                *)
 295                        break
 296                        ;;
 297                esac
 298                shift
 299        done
 300
 301        toplevel=$(pwd)
 302
 303        module_list |
 304        while read mode sha1 stage path
 305        do
 306                if test -e "$path"/.git
 307                then
 308                        say "Entering '$prefix$path'"
 309                        name=$(module_name "$path")
 310                        (
 311                                prefix="$prefix$path/"
 312                                clear_local_git_env
 313                                cd "$path" &&
 314                                eval "$@" &&
 315                                if test -n "$recursive"
 316                                then
 317                                        cmd_foreach "--recursive" "$@"
 318                                fi
 319                        ) ||
 320                        die "Stopping at '$path'; script returned non-zero status."
 321                fi
 322        done
 323}
 324
 325#
 326# Register submodules in .git/config
 327#
 328# $@ = requested paths (default to all)
 329#
 330cmd_init()
 331{
 332        # parse $args after "submodule ... init".
 333        while test $# -ne 0
 334        do
 335                case "$1" in
 336                -q|--quiet)
 337                        GIT_QUIET=1
 338                        ;;
 339                --)
 340                        shift
 341                        break
 342                        ;;
 343                -*)
 344                        usage
 345                        ;;
 346                *)
 347                        break
 348                        ;;
 349                esac
 350                shift
 351        done
 352
 353        module_list "$@" |
 354        while read mode sha1 stage path
 355        do
 356                # Skip already registered paths
 357                name=$(module_name "$path") || exit
 358                url=$(git config submodule."$name".url)
 359                test -z "$url" || continue
 360
 361                url=$(git config -f .gitmodules submodule."$name".url)
 362                test -z "$url" &&
 363                die "No url found for submodule path '$path' in .gitmodules"
 364
 365                # Possibly a url relative to parent
 366                case "$url" in
 367                ./*|../*)
 368                        url=$(resolve_relative_url "$url") || exit
 369                        ;;
 370                esac
 371
 372                git config submodule."$name".url "$url" ||
 373                die "Failed to register url for submodule path '$path'"
 374
 375                upd="$(git config -f .gitmodules submodule."$name".update)"
 376                test -z "$upd" ||
 377                git config submodule."$name".update "$upd" ||
 378                die "Failed to register update mode for submodule path '$path'"
 379
 380                say "Submodule '$name' ($url) registered for path '$path'"
 381        done
 382}
 383
 384#
 385# Update each submodule path to correct revision, using clone and checkout as needed
 386#
 387# $@ = requested paths (default to all)
 388#
 389cmd_update()
 390{
 391        # parse $args after "submodule ... update".
 392        orig_flags=
 393        while test $# -ne 0
 394        do
 395                case "$1" in
 396                -q|--quiet)
 397                        GIT_QUIET=1
 398                        ;;
 399                -i|--init)
 400                        init=1
 401                        ;;
 402                -N|--no-fetch)
 403                        nofetch=1
 404                        ;;
 405                -f|--force)
 406                        force=$1
 407                        ;;
 408                -r|--rebase)
 409                        update="rebase"
 410                        ;;
 411                --reference)
 412                        case "$2" in '') usage ;; esac
 413                        reference="--reference=$2"
 414                        orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 415                        shift
 416                        ;;
 417                --reference=*)
 418                        reference="$1"
 419                        ;;
 420                -m|--merge)
 421                        update="merge"
 422                        ;;
 423                --recursive)
 424                        recursive=1
 425                        ;;
 426                --)
 427                        shift
 428                        break
 429                        ;;
 430                -*)
 431                        usage
 432                        ;;
 433                *)
 434                        break
 435                        ;;
 436                esac
 437                orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 438                shift
 439        done
 440
 441        if test -n "$init"
 442        then
 443                cmd_init "--" "$@" || return
 444        fi
 445
 446        cloned_modules=
 447        module_list "$@" |
 448        while read mode sha1 stage path
 449        do
 450                if test "$stage" = U
 451                then
 452                        echo >&2 "Skipping unmerged submodule $path"
 453                        continue
 454                fi
 455                name=$(module_name "$path") || exit
 456                url=$(git config submodule."$name".url)
 457                update_module=$(git config submodule."$name".update)
 458                if test -z "$url"
 459                then
 460                        # Only mention uninitialized submodules when its
 461                        # path have been specified
 462                        test "$#" != "0" &&
 463                        say "Submodule path '$path' not initialized" &&
 464                        say "Maybe you want to use 'update --init'?"
 465                        continue
 466                fi
 467
 468                if ! test -d "$path"/.git -o -f "$path"/.git
 469                then
 470                        module_clone "$path" "$url" "$reference"|| exit
 471                        cloned_modules="$cloned_modules;$name"
 472                        subsha1=
 473                else
 474                        subsha1=$(clear_local_git_env; cd "$path" &&
 475                                git rev-parse --verify HEAD) ||
 476                        die "Unable to find current revision in submodule path '$path'"
 477                fi
 478
 479                if ! test -z "$update"
 480                then
 481                        update_module=$update
 482                fi
 483
 484                if test "$subsha1" != "$sha1"
 485                then
 486                        subforce=$force
 487                        # If we don't already have a -f flag and the submodule has never been checked out
 488                        if test -z "$subsha1" -a -z "$force"
 489                        then
 490                                subforce="-f"
 491                        fi
 492
 493                        if test -z "$nofetch"
 494                        then
 495                                # Run fetch only if $sha1 isn't present or it
 496                                # is not reachable from a ref.
 497                                (clear_local_git_env; cd "$path" &&
 498                                        ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
 499                                         test -z "$rev") || git-fetch)) ||
 500                                die "Unable to fetch in submodule path '$path'"
 501                        fi
 502
 503                        # Is this something we just cloned?
 504                        case ";$cloned_modules;" in
 505                        *";$name;"*)
 506                                # then there is no local change to integrate
 507                                update_module= ;;
 508                        esac
 509
 510                        case "$update_module" in
 511                        rebase)
 512                                command="git rebase"
 513                                action="rebase"
 514                                msg="rebased onto"
 515                                ;;
 516                        merge)
 517                                command="git merge"
 518                                action="merge"
 519                                msg="merged in"
 520                                ;;
 521                        *)
 522                                command="git checkout $subforce -q"
 523                                action="checkout"
 524                                msg="checked out"
 525                                ;;
 526                        esac
 527
 528                        (clear_local_git_env; cd "$path" && $command "$sha1") ||
 529                        die "Unable to $action '$sha1' in submodule path '$path'"
 530                        say "Submodule path '$path': $msg '$sha1'"
 531                fi
 532
 533                if test -n "$recursive"
 534                then
 535                        (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags") ||
 536                        die "Failed to recurse into submodule path '$path'"
 537                fi
 538        done
 539}
 540
 541set_name_rev () {
 542        revname=$( (
 543                clear_local_git_env
 544                cd "$1" && {
 545                        git describe "$2" 2>/dev/null ||
 546                        git describe --tags "$2" 2>/dev/null ||
 547                        git describe --contains "$2" 2>/dev/null ||
 548                        git describe --all --always "$2"
 549                }
 550        ) )
 551        test -z "$revname" || revname=" ($revname)"
 552}
 553#
 554# Show commit summary for submodules in index or working tree
 555#
 556# If '--cached' is given, show summary between index and given commit,
 557# or between working tree and given commit
 558#
 559# $@ = [commit (default 'HEAD'),] requested paths (default all)
 560#
 561cmd_summary() {
 562        summary_limit=-1
 563        for_status=
 564        diff_cmd=diff-index
 565
 566        # parse $args after "submodule ... summary".
 567        while test $# -ne 0
 568        do
 569                case "$1" in
 570                --cached)
 571                        cached="$1"
 572                        ;;
 573                --files)
 574                        files="$1"
 575                        ;;
 576                --for-status)
 577                        for_status="$1"
 578                        ;;
 579                -n|--summary-limit)
 580                        if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
 581                        then
 582                                :
 583                        else
 584                                usage
 585                        fi
 586                        shift
 587                        ;;
 588                --)
 589                        shift
 590                        break
 591                        ;;
 592                -*)
 593                        usage
 594                        ;;
 595                *)
 596                        break
 597                        ;;
 598                esac
 599                shift
 600        done
 601
 602        test $summary_limit = 0 && return
 603
 604        if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
 605        then
 606                head=$rev
 607                test $# = 0 || shift
 608        elif test -z "$1" -o "$1" = "HEAD"
 609        then
 610                # before the first commit: compare with an empty tree
 611                head=$(git hash-object -w -t tree --stdin </dev/null)
 612                test -z "$1" || shift
 613        else
 614                head="HEAD"
 615        fi
 616
 617        if [ -n "$files" ]
 618        then
 619                test -n "$cached" &&
 620                die "--cached cannot be used with --files"
 621                diff_cmd=diff-files
 622                head=
 623        fi
 624
 625        cd_to_toplevel
 626        # Get modified modules cared by user
 627        modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
 628                sane_egrep '^:([0-7]* )?160000' |
 629                while read mod_src mod_dst sha1_src sha1_dst status name
 630                do
 631                        # Always show modules deleted or type-changed (blob<->module)
 632                        test $status = D -o $status = T && echo "$name" && continue
 633                        # Also show added or modified modules which are checked out
 634                        GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
 635                        echo "$name"
 636                done
 637        )
 638
 639        test -z "$modules" && return
 640
 641        git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
 642        sane_egrep '^:([0-7]* )?160000' |
 643        cut -c2- |
 644        while read mod_src mod_dst sha1_src sha1_dst status name
 645        do
 646                if test -z "$cached" &&
 647                        test $sha1_dst = 0000000000000000000000000000000000000000
 648                then
 649                        case "$mod_dst" in
 650                        160000)
 651                                sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
 652                                ;;
 653                        100644 | 100755 | 120000)
 654                                sha1_dst=$(git hash-object $name)
 655                                ;;
 656                        000000)
 657                                ;; # removed
 658                        *)
 659                                # unexpected type
 660                                echo >&2 "unexpected mode $mod_dst"
 661                                continue ;;
 662                        esac
 663                fi
 664                missing_src=
 665                missing_dst=
 666
 667                test $mod_src = 160000 &&
 668                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
 669                missing_src=t
 670
 671                test $mod_dst = 160000 &&
 672                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
 673                missing_dst=t
 674
 675                total_commits=
 676                case "$missing_src,$missing_dst" in
 677                t,)
 678                        errmsg="  Warn: $name doesn't contain commit $sha1_src"
 679                        ;;
 680                ,t)
 681                        errmsg="  Warn: $name doesn't contain commit $sha1_dst"
 682                        ;;
 683                t,t)
 684                        errmsg="  Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
 685                        ;;
 686                *)
 687                        errmsg=
 688                        total_commits=$(
 689                        if test $mod_src = 160000 -a $mod_dst = 160000
 690                        then
 691                                range="$sha1_src...$sha1_dst"
 692                        elif test $mod_src = 160000
 693                        then
 694                                range=$sha1_src
 695                        else
 696                                range=$sha1_dst
 697                        fi
 698                        GIT_DIR="$name/.git" \
 699                        git rev-list --first-parent $range -- | wc -l
 700                        )
 701                        total_commits=" ($(($total_commits + 0)))"
 702                        ;;
 703                esac
 704
 705                sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
 706                sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
 707                if test $status = T
 708                then
 709                        if test $mod_dst = 160000
 710                        then
 711                                echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
 712                        else
 713                                echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
 714                        fi
 715                else
 716                        echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
 717                fi
 718                if test -n "$errmsg"
 719                then
 720                        # Don't give error msg for modification whose dst is not submodule
 721                        # i.e. deleted or changed to blob
 722                        test $mod_dst = 160000 && echo "$errmsg"
 723                else
 724                        if test $mod_src = 160000 -a $mod_dst = 160000
 725                        then
 726                                limit=
 727                                test $summary_limit -gt 0 && limit="-$summary_limit"
 728                                GIT_DIR="$name/.git" \
 729                                git log $limit --pretty='format:  %m %s' \
 730                                --first-parent $sha1_src...$sha1_dst
 731                        elif test $mod_dst = 160000
 732                        then
 733                                GIT_DIR="$name/.git" \
 734                                git log --pretty='format:  > %s' -1 $sha1_dst
 735                        else
 736                                GIT_DIR="$name/.git" \
 737                                git log --pretty='format:  < %s' -1 $sha1_src
 738                        fi
 739                        echo
 740                fi
 741                echo
 742        done |
 743        if test -n "$for_status"; then
 744                if [ -n "$files" ]; then
 745                        echo "# Submodules changed but not updated:"
 746                else
 747                        echo "# Submodule changes to be committed:"
 748                fi
 749                echo "#"
 750                sed -e 's|^|# |' -e 's|^# $|#|'
 751        else
 752                cat
 753        fi
 754}
 755#
 756# List all submodules, prefixed with:
 757#  - submodule not initialized
 758#  + different revision checked out
 759#
 760# If --cached was specified the revision in the index will be printed
 761# instead of the currently checked out revision.
 762#
 763# $@ = requested paths (default to all)
 764#
 765cmd_status()
 766{
 767        # parse $args after "submodule ... status".
 768        orig_flags=
 769        while test $# -ne 0
 770        do
 771                case "$1" in
 772                -q|--quiet)
 773                        GIT_QUIET=1
 774                        ;;
 775                --cached)
 776                        cached=1
 777                        ;;
 778                --recursive)
 779                        recursive=1
 780                        ;;
 781                --)
 782                        shift
 783                        break
 784                        ;;
 785                -*)
 786                        usage
 787                        ;;
 788                *)
 789                        break
 790                        ;;
 791                esac
 792                orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 793                shift
 794        done
 795
 796        module_list "$@" |
 797        while read mode sha1 stage path
 798        do
 799                name=$(module_name "$path") || exit
 800                url=$(git config submodule."$name".url)
 801                displaypath="$prefix$path"
 802                if test "$stage" = U
 803                then
 804                        say "U$sha1 $displaypath"
 805                        continue
 806                fi
 807                if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
 808                then
 809                        say "-$sha1 $displaypath"
 810                        continue;
 811                fi
 812                set_name_rev "$path" "$sha1"
 813                if git diff-files --ignore-submodules=dirty --quiet -- "$path"
 814                then
 815                        say " $sha1 $displaypath$revname"
 816                else
 817                        if test -z "$cached"
 818                        then
 819                                sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
 820                                set_name_rev "$path" "$sha1"
 821                        fi
 822                        say "+$sha1 $displaypath$revname"
 823                fi
 824
 825                if test -n "$recursive"
 826                then
 827                        (
 828                                prefix="$displaypath/"
 829                                clear_local_git_env
 830                                cd "$path" &&
 831                                eval cmd_status "$orig_args"
 832                        ) ||
 833                        die "Failed to recurse into submodule path '$path'"
 834                fi
 835        done
 836}
 837#
 838# Sync remote urls for submodules
 839# This makes the value for remote.$remote.url match the value
 840# specified in .gitmodules.
 841#
 842cmd_sync()
 843{
 844        while test $# -ne 0
 845        do
 846                case "$1" in
 847                -q|--quiet)
 848                        GIT_QUIET=1
 849                        shift
 850                        ;;
 851                --)
 852                        shift
 853                        break
 854                        ;;
 855                -*)
 856                        usage
 857                        ;;
 858                *)
 859                        break
 860                        ;;
 861                esac
 862        done
 863        cd_to_toplevel
 864        module_list "$@" |
 865        while read mode sha1 stage path
 866        do
 867                name=$(module_name "$path")
 868                url=$(git config -f .gitmodules --get submodule."$name".url)
 869
 870                # Possibly a url relative to parent
 871                case "$url" in
 872                ./*|../*)
 873                        url=$(resolve_relative_url "$url") || exit
 874                        ;;
 875                esac
 876
 877                say "Synchronizing submodule url for '$name'"
 878                git config submodule."$name".url "$url"
 879
 880                if test -e "$path"/.git
 881                then
 882                (
 883                        clear_local_git_env
 884                        cd "$path"
 885                        remote=$(get_default_remote)
 886                        git config remote."$remote".url "$url"
 887                )
 888                fi
 889        done
 890}
 891
 892# This loop parses the command line arguments to find the
 893# subcommand name to dispatch.  Parsing of the subcommand specific
 894# options are primarily done by the subcommand implementations.
 895# Subcommand specific options such as --branch and --cached are
 896# parsed here as well, for backward compatibility.
 897
 898while test $# != 0 && test -z "$command"
 899do
 900        case "$1" in
 901        add | foreach | init | update | status | summary | sync)
 902                command=$1
 903                ;;
 904        -q|--quiet)
 905                GIT_QUIET=1
 906                ;;
 907        -b|--branch)
 908                case "$2" in
 909                '')
 910                        usage
 911                        ;;
 912                esac
 913                branch="$2"; shift
 914                ;;
 915        --cached)
 916                cached="$1"
 917                ;;
 918        --)
 919                break
 920                ;;
 921        -*)
 922                usage
 923                ;;
 924        *)
 925                break
 926                ;;
 927        esac
 928        shift
 929done
 930
 931# No command word defaults to "status"
 932test -n "$command" || command=status
 933
 934# "-b branch" is accepted only by "add"
 935if test -n "$branch" && test "$command" != add
 936then
 937        usage
 938fi
 939
 940# "--cached" is accepted only by "status" and "summary"
 941if test -n "$cached" && test "$command" != status -a "$command" != summary
 942then
 943        usage
 944fi
 945
 946"cmd_$command" "$@"